/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#ifndef GRAPHIC_MOVECMD_H
#define GRAPHIC_MOVECMD_H

#include "command.h"

class MoveCmd: public Command
{
	public:
		MoveCmd(GraphicMaster *,Coord,Coord);

		virtual void execute();

		void set_movement(Coord,Coord);
		void get_movement(Coord &,Coord &) const;

		virtual ClassId get_classid() const;
		virtual boolean is_a(ClassId) const;
	protected:
	private:
		Coord _dx,_dy;
};

inline void MoveCmd::set_movement(Coord x,Coord y)
{
	_dx=x;
	_dy=y;
}

inline void MoveCmd::get_movement(Coord &x,Coord &y) const
{
	x=_dx;
	y=_dy;
}

#endif
