/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#ifndef GRAPHIC_SLRECT_H
#define GRAPHIC_SLRECT_H

#include <InterViews/coord.h>

class Brush;
class Color;
class Canvas;
class Transformer;

class SlidingLine
{
	public:
		SlidingLine(Coord,Coord,Coord,Coord,Canvas *);
		virtual ~SlidingLine();

		void translate(Coord,Coord);
		void endpoints(Coord &,Coord &,Coord &,Coord &) const; // inline
	protected:
		void draw();
	private:
		Coord _fixx,_fixy;
		Coord _flexx,_flexy;
		Transformer *_tf;
		Color *_color;
		Brush *_brush;
		Canvas *_c;
};

inline void SlidingLine::endpoints(Coord &x1,Coord &y1,Coord &x2,Coord &y2) const
{
	x1=_fixx;
	y1=_fixy;
	x2=_flexx;
	y2=_flexy;
}

class SlidingRect
{
	public:
		SlidingRect(Coord,Coord,Coord,Coord,Canvas *);
		virtual ~SlidingRect();

		void translate(Coord,Coord);
		void scale(Coord,Coord);
		void rotate(Coord);

		void getrect(Coord &,Coord &,Coord &,Coord &) const;

		Transformer *transformer();
		void transformer(Transformer *);
	protected:
		void draw();
	private:
		Coord _l,_b,_r,_t;
		Transformer *_tf;
		Color *_color;
		Brush *_brush;
		Canvas *_c;
};

inline Transformer *SlidingRect::transformer()
{
	return _tf;
}

class GrowingRect: public SlidingRect
{
	public:
		GrowingRect(Coord,Coord,Coord,Coord,Canvas *);
		virtual ~GrowingRect();

		void flex_point(Coord,Coord);
};

#endif
