/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#ifndef GRAPHIC_SPLINES_H
#define GRAPHIC_SPLINES_H

#include "graphic.h"

class Open_BSpline: public Graphic
{
	public:
		Open_BSpline (const Brush *,const Color *,const Color *,Coord *,Coord *,int,Transformer * =nil);
		virtual Glyph* clone() const;

		virtual ClassId get_classid() const;
		virtual boolean is_a(ClassId) const;
	protected:
		Open_BSpline(Open_BSpline*);
		virtual ~Open_BSpline ();
};

class Closed_BSpline: public Graphic
{
	public:
		Closed_BSpline(const Brush *, const Color *,const Color *,Coord *x, Coord *y,int,Transformer * =nil);
		virtual Glyph *clone() const;

		virtual ClassId get_classid() const;
		virtual boolean is_a(ClassId) const;
	protected:
		Closed_BSpline(Closed_BSpline *);
		virtual ~Closed_BSpline();
};

#endif
