/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#include <Graphic/cutcmd.h>
#include <Graphic/graphicmaster.h>
#include <Graphic/glyphviewer.h>
#include <Graphic/handles.h>

//
// CutCmd - deleting the selected graphics
//

CutCmd::CutCmd(GraphicMaster *gm): Command(gm)
{
}

void CutCmd::execute()
{
	GraphicMaster *gm=graphic_master();
	GlyphViewer *gv=gm->glyphviewer();
	GraphicList *s=gm->selection();
	long i,count=s->count();
	Coord tol=Handles::tol();

	for(i=count-1;i>=0;i--)
	{
		GlyphIndex cgm=gm->count_();
		GlyphIndex ll;
		Coord l,b,r,t;
		Graphic *g=s->item(i);

		g->delete_handles();                   // unmark the graphic
		g->disconnect_all();                   // connections must be destroyed else core
		g->getbounds(l,b,r,t);                 // for restoring
		gv->damage(l-tol,b-tol,r+tol,t+tol);   // the screen
		s->remove(i);
		for(ll=0;ll<cgm;ll++) 
			if(g==gm->component_(ll))      // get the graphic's index and remove it
			{
				gm->remove_(ll);
				break;
			}
	}
	gm->update(gv);
}

ClassId CutCmd::get_classid() const
{
	return CUT_CMD;
}

boolean CutCmd::is_a(ClassId id) const
{
	return id==CUT_CMD || Command::is_a(id);
}

