/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#include <Graphic/graphicmaster.h>
#include <Graphic/noptool.h>

//
// NOPTool -- does nothing (no operation)
//

NOPTool::NOPTool(GraphicMaster *gm): Tool(gm)
{
}

boolean NOPTool::grasp(const Event &)
{
	return false;
}


boolean NOPTool::manipulating(const Event &)
{
	return false;
}

boolean NOPTool::effect(const Event &)
{
	return false;
}

ClassId NOPTool::get_classid() const
{
	return NOP_TOOL;
}

boolean NOPTool::is_a(ClassId id) const
{
	return id==NOP_TOOL||Tool::is_a(id);
}

